/*
 * This file was automatically generated by EvoSuite
 * Thu Jun 23 13:12:40 GMT 2022
 */

package ir.ramtung.impl1;

import ir.ramtung.sts01.LibraryException;
import org.junit.Test;
import static org.junit.Assert.*;
import static org.evosuite.runtime.EvoAssertions.*;
import ir.ramtung.impl1.Book;
import ir.ramtung.impl1.Document;
import ir.ramtung.impl1.Loan;
import ir.ramtung.impl1.Magazine;
import ir.ramtung.impl1.Member;
import ir.ramtung.impl1.Professor;
import ir.ramtung.impl1.Reference;
import ir.ramtung.impl1.Student;
import org.evosuite.runtime.EvoRunner;
import org.evosuite.runtime.EvoRunnerParameters;
import org.junit.runner.RunWith;

@RunWith(EvoRunner.class) @EvoRunnerParameters(mockJVMNonDeterminism = true, useVFS = true, useVNET = true, resetStaticState = true, separateClassLoader = true, useJEE = true) 
public class Loan_ESTest extends Loan_ESTest_scaffolding {

  @Test(timeout = 4000)
  public void test00()  throws Throwable  {
      Professor professor0 = new Professor("}w&(>ouQ'");
      Magazine magazine0 = new Magazine("}w&(>ouQ'", 2, 1390);
      Loan loan0 = new Loan(professor0, magazine0, 0);
      int int0 = loan0.getPenalty(2);
      assertEquals(0, int0);
  }

  @Test(timeout = 4000)
  public void test01()  throws Throwable  {
      Student student0 = new Student("=myM", "d]1vHp.][7Ci?*mgJ *");
      Reference reference0 = new Reference("ir.ramtung.impl1.Loan");
      Loan loan0 = new Loan(student0, reference0, 2);
      loan0.return_(7);
  }

  @Test(timeout = 4000)
  public void test02()  throws Throwable  {
      Student student0 = new Student("Already extended twice", "Already extended twice");
      Book book0 = new Book("Already extended twice");
      Loan loan0 = new Loan(student0, book0, 4);
      loan0.extend(14);
  }

  @Test(timeout = 4000)
  public void test03()  throws Throwable  {
      Professor professor0 = new Professor("9jPMOa/k_N'^}$B}l");
      Reference reference0 = new Reference("{AH[>%S!l~1gmp?7");
      Loan loan0 = new Loan(professor0, reference0, 0);
      int int0 = loan0.getPenalty(304);
      assertEquals(1432000, int0);
  }

  @Test(timeout = 4000)
  public void test04()  throws Throwable  {
      Professor professor0 = new Professor("9jPMOa/k_N'^}$B}l");
      Reference reference0 = new Reference("{AH[>%S!l~1gmp?7");
      Loan loan0 = new Loan(professor0, reference0, 0);
      int int0 = loan0.getPenalty(10);
      assertEquals((-38000), int0);
  }

  @Test(timeout = 4000)
  public void test05()  throws Throwable  {
      Professor professor0 = new Professor("irCra2tung.impl1.Magazine");
      Reference reference0 = new Reference("irCra2tung.impl1.Magazine");
      Loan loan0 = new Loan(professor0, reference0, (-468));
      int int0 = loan0.getPenalty((-468));
      assertEquals(0, int0);
  }

  @Test(timeout = 4000)
  public void test06()  throws Throwable  {
      Professor professor0 = new Professor("lU\"Q{");
      Reference reference0 = new Reference("ir.ramtung.impl1.Magazine");
      Loan loan0 = new Loan(professor0, reference0, (-2919));
      loan0.return_(0);
  }

  @Test(timeout = 4000)
  public void test07()  throws Throwable  {
      Professor professor0 = new Professor("9jPMOa/k_N'^}$B}l");
      Reference reference0 = new Reference("{AH[>%S!l~1gmp?7");
      Loan loan0 = new Loan(professor0, reference0, 0);
      loan0.return_((-593));
  }

  @Test(timeout = 4000)
  public void test08()  throws Throwable  {
      Student student0 = new Student(">\"S6", ">\"S6");
      Reference reference0 = new Reference(">\"S6");
      Loan loan0 = new Loan(student0, reference0, 2400);
      loan0.extend((-44));
      loan0.extend((-44));
      try { 
        loan0.extend((-44));
        fail("Expecting exception: Exception");
      
      } catch(Exception e) {
          if (!(e instanceof LibraryException)) {
              fail("Unexpected exception");
          }
         //
         // Already extended twice
         //
         verifyException("ir.ramtung.impl1.Loan", e);
      }
  }

  @Test(timeout = 4000)
  public void test09()  throws Throwable  {
      Student student0 = new Student("Invalidargumrnt to lon constru1or", "Invalidargumrnt to lon constru1or");
      Book book0 = new Book("Invalidargumrnt to lon constru1or");
      Loan loan0 = new Loan(student0, book0, 5430);
      try { 
        loan0.extend(5430);
        fail("Expecting exception: Exception");
      
      } catch(Exception e) {
          if (!(e instanceof LibraryException)) {
              fail("Unexpected exception");
          }
         //
         // Cannot extend on the same day borrowed
         //
         verifyException("ir.ramtung.impl1.Loan", e);
      }
  }

  @Test(timeout = 4000)
  public void test10()  throws Throwable  {
      Professor professor0 = new Professor("9jPMOa/k_N'^}$B}l");
      Reference reference0 = new Reference("{AH[>%S!l~1gmp?7");
      Loan loan0 = new Loan(professor0, reference0, 0);
      try { 
        loan0.extend(224);
        fail("Expecting exception: Exception");
      
      } catch(Exception e) {
          if (!(e instanceof LibraryException)) {
              fail("Unexpected exception");
          }
         //
         // Cannot extend a late loan
         //
         verifyException("ir.ramtung.impl1.Loan", e);
      }
  }

  @Test(timeout = 4000)
  public void test11()  throws Throwable  {
      Professor professor0 = new Professor("9jPMOa/k_N'^}$B}l");
      Reference reference0 = new Reference("{AH[>%S!l~1gmp?7");
      Loan loan0 = new Loan(professor0, reference0, 0);
      boolean boolean0 = loan0.isBy(professor0);
      assertTrue(boolean0);
  }

  @Test(timeout = 4000)
  public void test12()  throws Throwable  {
      Professor professor0 = new Professor("irCra2tung.impl1.Magazine");
      Reference reference0 = new Reference("irCra2tung.impl1.Magazine");
      Loan loan0 = new Loan(professor0, reference0, (-468));
      Student student0 = new Student("irCra2tung.impl1.Magazine", "irCra2tung.impl1.Magazine");
      boolean boolean0 = loan0.isBy(student0);
      assertFalse(boolean0);
  }

  @Test(timeout = 4000)
  public void test13()  throws Throwable  {
      Student student0 = new Student("Invalidargumrnt to lon constru1or", "Invalidargumrnt to lon constru1or");
      Book book0 = new Book("Invalidargumrnt to lon constru1or");
      Loan loan0 = new Loan(student0, book0, 5430);
      boolean boolean0 = loan0.isFor((Document) null);
      assertFalse(boolean0);
  }

  @Test(timeout = 4000)
  public void test14()  throws Throwable  {
      Professor professor0 = new Professor((String) null);
      Loan loan0 = null;
      try {
        loan0 = new Loan(professor0, (Document) null, 5435);
        fail("Expecting exception: Exception");
      
      } catch(Throwable e) {
          if (!(e instanceof LibraryException)) {
              fail("Unexpected exception");
          }
         //
         // Invalid argument to loan constructor
         //
         verifyException("ir.ramtung.impl1.Loan", e);
      }
  }

  @Test(timeout = 4000)
  public void test15()  throws Throwable  {
      Professor professor0 = new Professor("9jPMOa/k_N'^}$B}l");
      Reference reference0 = new Reference("{AH[>%S!l~1gmp?7");
      Loan loan0 = new Loan(professor0, reference0, 0);
      boolean boolean0 = loan0.isFor(reference0);
      assertTrue(boolean0);
  }

  @Test(timeout = 4000)
  public void test16()  throws Throwable  {
      Book book0 = new Book("R@0 _=Ro#Id!ZI7?,u_");
      Loan loan0 = null;
      try {
        loan0 = new Loan((Member) null, book0, (-981));
        fail("Expecting exception: Exception");
      
      } catch(Throwable e) {
          if (!(e instanceof LibraryException)) {
              fail("Unexpected exception");
          }
         //
         // Invalid argument to loan constructor
         //
         verifyException("ir.ramtung.impl1.Loan", e);
      }
  }
}
